;+++++++++++++++++++++++++++++++++++++++++++
;+               Tunnelflug                +
;+                                         +
;+++++++++++++++++++++++++++++++++++++++++++
;+ erstellt von Damian 'Tritium' Rothkegel +
;+ http://tritium.zxq.net                  +
;+++++++++++++++++++++++++++++++++++++++++++

Dim tunnel$(41,20,2)

;Grafikmodus initialisieren
Graphics 320,240,0,2
SetBuffer BackBuffer()
HidePointer
SeedRnd MilliSecs()
AppTitle "Tunnelflug"

Global r,g,b,zeit = MilliSecs(),schiffx=120,schiffy=72,punkte#,timerstep#=1

;Men
.menu
menu()

;Tunnel initialisieren
tunnel_init()

;Mainloop
Repeat
	Cls
	
	If tunnel_alg() = 1 Then
		Delay 500
		
		For i=0 To 228 Step 12
			Color 255,0,0
			Text 0,i,"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww"
			Flip
			Delay 500 - i*2
		Next
		
		Cls
		Color 0,0,255
		Text 26,60,"Da gab es wohl einen Knall im All!"
		Text 60,120,"Ihre Punktzahl: " + Int(punkte)
		Flip
		FlushKeys
		WaitKey
		timerstep = 1
		Goto menu
	EndIf
	
	tunnel_draw()
	
	If KeyDown(200) Then schiffy = schiffy - 12
	If KeyDown(203) Then schiffx = schiffx - 8
	If KeyDown(208) Then schiffy = schiffy + 12
	If KeyDown(205) Then schiffx = schiffx + 8
	
	punkte = punkte + 0.1
	
	For i=0 To Int(timerstep/25)
		x = Rand(0,319)
		y = Rand(0,239)
		
		CopyRect 0,y,320,1,Rand(-3,3),y
		CopyRect x,0,1,240,x,Rand(-3,3)
	Next
	
	Delay 1000/timerstep
	If timerstep < 1000 Then timerstep = timerstep + 0.25
	Flip
Until KeyHit(1)
Goto menu

;Funktionen
Function menu()
	Cls
	Color 0,240,0
	Locate 0,0
	Print "---------------------------------------"
	Print "-             Tunnelflug              -"
	Print "---------------------------------------"
	Print
	Print
	Print
	Print : Color 30,30,255
	Print "1 - Spiel starten"
	Print "2 - Spiel beenden"
	Print
	Print
	Print
	Print
	Print
	Print
	Print
	Print : Color 120,0,0
	Print "Ein Spiel von Damian 'Tritium' Rothkegel"
	Locate 3,150 : Color 255,255,255
	eingabe = Input()
	
	If eingabe = 2 Then
		For i=0 To 20
			Delay 50
			Print
		Next
		
		Color 0,255,255
		Print "Herzlichen Glckwunsch, Sie haben dieses"
		Print "Spiel genau " + (MilliSecs()-zeit)/1000 + " Sekunden ausgehalten!"
		Print
		Print
		Print
		Print
		Print
		Print
		Print
		Print "Weitere Spiele unter"
		Print
		Print "++++++++++++++++++++++++++++++++++++++++"
		Print "+      http://www.tritium.zxq.net      +"
		Print "++++++++++++++++++++++++++++++++++++++++"
		Print
		Print
		Print
		Delay 1000
		WaitKey
		End
	ElseIf eingabe < 1 Or eingabe > 2 Then
		RuntimeError "Sie haben es leider nicht geschafft, sich zwischen 1 und 2 zu entscheiden." + Chr(13) + Chr(13) + "Aber verlieren Sie nicht den Mut, nchstes Mal klappt es bestimmt besser!" 
	EndIf
	
	Cls : Locate 0,70 : Color 0,255,0
	
	Print "                333333"
	Print "               3      3"
	Print "                      3"
	Print "                   333"
	Print "                      3"
	Print "               3      3"
	Print "                333333"
	
	Delay 1000
	
	Cls : Locate 0,70 : Color 255,255,0
	
	Print "                  2222"
	Print "                 2    2"
	Print "                     2"
	Print "                    2"
	Print "                   2"
	Print "                  2"
	Print "                 222222"
	
	Delay 1000
	
	Cls : Locate 0,70 : Color 255,0,0
	
	Print "                    1"
	Print "                   11"
	Print "                  1 1"
	Print "                    1"
	Print "                    1"
	Print "                    1"
	Print "                  1111"
	
	Delay 1000
End Function

Function tunnel_init()
	For x=1 To 38
		tunnel(x,0,0) = "I"
		tunnel(x,1,0) = "#"
		tunnel(x,18,0) = "#"
		tunnel(x,19,0) = "I"
		If x > 2 And x < 37 tunnel(x,1,1) = "v"
		If x > 2 And x < 37 tunnel(x,2,1) = "|"
		If x > 2 And x < 37 tunnel(x,17,1) = "|"
		If x > 2 And x < 37 tunnel(x,18,1) = "^"
		tunnel(x,2,2) = ":"
		tunnel(x,3,2) = ":"
		tunnel(x,16,2) = ":"
		tunnel(x,17,2) = ":"
	Next
	
	For y=2 To 17
		tunnel(0,y,0) = "="
		tunnel(1,y,0) = "#"
		tunnel(38,y,0) = "#"
		tunnel(39,y,0) = "="
		If y > 2 And y < 17 tunnel(1,y,1) = ">"
		If y > 2 And y < 17 tunnel(2,y,1) = "-"
		If y > 2 And y < 17 tunnel(37,y,1) = "-"
		If y > 2 And y < 17 tunnel(38,y,1) = "<"
		tunnel(2,y,2) = ":"
		tunnel(3,y,2) = ":"
		tunnel(4,y,2) = ":"
		tunnel(35,y,2) = ":"
		tunnel(36,y,2) = ":"
		tunnel(37,y,2) = ":"
	Next
	
	tunnel(0,0,0) = "X"
	tunnel(0,1,0) = "="
	tunnel(39,0,0) = "X"
	tunnel(39,1,0) = "="
	tunnel(0,18,0) = "="
	tunnel(0,19,0) = "X"
	tunnel(39,18,0) = "="
	tunnel(39,19,0) = "X"
	tunnel(2,2,1) = "%"
	tunnel(37,2,1) = "%"
	tunnel(2,17,1) = "%"
	tunnel(37,17,1) = "%"
End Function

Function tunnel_alg()
	If Rand(0,25) = 0 Then
		x = tunnel(40,20,0)
		y = tunnel(41,20,0)
		
		x = x + Rand(-1,1)
		y = y + Rand(-1,1)
		
		If x < -12 Then x = -12
		If x > 12 Then x = 12
		If y < -12 Then y = -12
		If y > 12 Then y = 12
		
		tunnel(40,20,0) = x
		tunnel(41,20,0) = y
	EndIf
	
	x1 = tunnel(40,20,0)
	y1 = tunnel(41,20,0)
	x2 = tunnel(40,20,1)
	y2 = tunnel(41,20,1)
	
	If (x1 - x2) > 1 Then
		tunnel(40,20,1) = x2 + 1
	ElseIf (x1 - x2) < -1 Then
		tunnel(40,20,1) = x2 - 1
	ElseIf (y1 - y2) > 1 Then
		tunnel(41,20,1) = y2 + 1
	ElseIf (y1 - y2) < -1 Then
		tunnel(41,20,1) = y2 - 1
	EndIf
	
	x1 = tunnel(40,20,1)
	y1 = tunnel(41,20,1)
	x2 = tunnel(40,20,2)
	y2 = tunnel(41,20,2)
	
	If (x1 - x2) > 1 Then
		tunnel(40,20,2) = x2 + 1
	ElseIf (x1 - x2) < -1 Then
		tunnel(40,20,2) = x2 - 1
	ElseIf (y1 - y2) > 1 Then
		tunnel(41,20,2) = y2 + 1
	ElseIf (y1 - y2) < -1 Then
		tunnel(41,20,2) = y2 - 1
	EndIf
	
	;Auf Kollision prfen
	If schiffx < Int(tunnel(40,20,0))*8+8 Or schiffx > Int(tunnel(40,20,2))*8+208 Or schiffy < Int(tunnel(41,20,0))*12+8 Or schiffy > Int(tunnel(41,20,0))*12+172
		schiffx = 120
		schiffy = 72
		Return 1
	EndIf
End Function

Function tunnel_draw()
	For schicht=2 To 0 Step -1
		If schicht = 0 Then
			Color 0,0,0
			Rect Int(tunnel(40,20,0))*8-40,Int(tunnel(41,20,0))*12-60,400,60
			Rect Int(tunnel(40,20,0))*8-40,Int(tunnel(41,20,0))*12+240,400,60
			Rect Int(tunnel(40,20,0))*8-40,Int(tunnel(41,20,0))*12,40,320
			Rect Int(tunnel(40,20,0))*8+320,Int(tunnel(41,20,0))*12,40,320
		EndIf
		
		For y=0 To 19
			For x=0 To 39
				If tunnel(x,y,schicht) <> "" Then
					Color 0,0,0
					Rect x*8+Int(tunnel(40,20,schicht))*8,y*12+Int(tunnel(41,20,schicht))*12,8,12
					
					Color schicht*127,(2-schicht)*127,0
					
					Text x*8+Int(tunnel(40,20,schicht))*8,y*12+Int(tunnel(41,20,schicht))*12,tunnel(x,y,schicht)
				EndIf
			Next
		Next
	Next
	
	Color 20,20,255
	Text schiffx,schiffy   ,"    ___"
	Text schiffx,schiffy+12,"   / : \"
	Text schiffx,schiffy+24,"~~_ {} _~~"
	Text schiffx,schiffy+36," |#|---|#|"
	Text schiffx,schiffy+48,"  ^     ^"
	
	Color 0,0,0
	Rect 0,0,120,13
	Color 240,240,240
	Text 0,0,"Punkte: " + Int(punkte)
End Function